---
title: XRSession.onsqueezeend
slug: Web/API/XRSession/onsqueezeend
tags:
  - API
  - AR
  - Event Handler
  - Primary
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - action
  - augmented
  - onsqueezeend
  - squeeze
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The {{domxref("XRSession")}} interface's <code><strong>onsqueezeend</strong></code> event handler property is a function to be invokedn when the {{domxref("XRSession.squeezeend_event", "squeezeend")}} event sent to an <code>XRSession</code> when a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> ends.</span> This is sent immediately after the {{domxref("XRSession.squeeze_event", "squeeze")}} event, which announces the <em>successful</em> completion of the squeeze action. The <code>squeezeend</code> event handler is where you handle closing out a squeeze action whether it was successfully completed or not.</p>

<p>To learn more about how the sequence of squeeze events works, see {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Inputs", "Primary squeeze actions")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrSession</em>.onsqueezeend = <em>squeezeendHandlerFunction</em>;</pre>

<h3 id="Value">Value</h3>

<p>A function to be invoked whenever the {{domxref("XRSession")}} receives a {{domxref("XRSession.squeezeend_event", "squeezestart")}} event, indicating the ending of a primary squeeze action.</p>

<h2 id="Examples">Examples</h2>

<p>This snippet of code adds a simple handler for the <code>squeezeend</code> event, which responds only to events on the user's dominant hand. In response to the end of the squeeze operation, this code looks to see if there is an object currently being held by the user by checking to see if the variable <code>user.heldObject</code> contains a reference to an object representing the held item.</p>

<p>If <code>heldObject</code> has an object reference, that object is passed to a function called <code>cancelObjectDrag()</code>, which would be written to return the object to its original position. This takes care of the situation in which the drag is aborted or canceled.</p>

<pre class="brush: js">xrSession.onsqueezeend = event =&gt; {
  if (event.inputSource.handedness == user.handedness) {
    let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace, myRefSpace;

    if (user.heldObject) {
       cancelObjectDrag(user.heldObject);
    }
  }
};
</pre>

<p>This code presumes that if the user actually intentionally completed the drag, <code>user.heldObject</code> will be <code>null</code> here. That's because (in this example, at least) the handler for the {{domxref("XRSession.squeeze_event", "squeeze")}} event has already dropped the object into its new location and then cleared the value of <code>heldObject</code> to indicate that the user is no longer holding anything.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrsession-onsqueezeend","XRSession.onsqueezeend")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRSession.onsqueezeend")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li>The other <code>onsqueeze*</code> handlers: {{DOMxRef("XRSession.onsqueezestart", "onsqueezestart")}} and {{DOMxRef("XRSession.onsqueeze", "onsqueeze")}}</li>
 <li>The {{domxref("XRSession.squeeze_event", "squeeze")}}, {{domxref("XRSession.squeezestart_event", "squeezestart")}}, and {{domxref("XRSession.squeezeend_event", "squeezeend")}} events</li>
</ul>
